[V2.5.0.1]
1. Fix P2P CLIENT use PBC to connect P2P GO as negotiate by KEYPAD / DISPLAY.
2. Fix P2P CLIENT difficult connect on P2P GO need scan times with wrong BSSID.
3. Fix P2P CLIENT not use N-rate transmit data to GO.
4. Fix P2P concurrent mode as INFRA + P2P_CLIENT with different HT_BW.
5. Fix P2P Link Down not turn back to Listen Channel cause can¡¦t be found.

[V2.5.0.0]
1. Support WIFI Direct(WIFI P2P).
2. supporting Linux Kernel 2.6.35.
3. Fixed Ad-hoc issue: STA didn't use legacy rate when STA is Ad-hoc creator and security is OPEN-WEP or WPAPSK-TKIP.
4. Fixed WPS issue: Beacon lost when STA tries to do WPS with WPS AP or STA connects to hidden AP.
5. Fixed WPS issue: WPS procedure is taking much longer than before.
6. Corrected WPS behavior: According to the response from WFA: while doing PBC, STA shall stop if STA finds more than one AP avaliable.
7. Fixed issue: WPS failed with Ralink WpaSupplicant when STA's privacy is different from AP's privacy. (for example: AP is WPA2PSK but STA is OPEN)
8. Fixed Ralink WpaSupplicant issue - Scan table didn't include RSSI.
9. Fixed issue: STA had problem to show 32-bytes SSID when user uses "iwpriv ra0 show SSID" or "iwpriv ra0 stat" to check SSID of WSC profile.
10. Fixed issue: If there are two APs have same SSID, AuthMode and EncrypType but different WPAPSK key, 
				 driver will only try the AP with better RSSI. 
				 If that AP with better RSSI has the different WPAPSK with STA, 
				 driver still keeps trying to connect that AP with better RSSI.
11. Refine the stack size of all functions to be smaller than 1024B.
12. Fixed WPS issue: When session overlap detect, the WPS LED will not turn off for WPS LED mode 9 after 2 minutes timeout.
13. Fixed issue: Use wrong rate index in send_monitor_packets().
14. Improve scan mechanism.
15. Fixed issue: STA supports the WPA authentication which group cipher is WEP.
16. Support to generate random WSC 4-digits PIN.
17. Support Intel WIDI (only DPAW has Intel WIDI)
18. Fixed issue: Single SKU Bandedge Delta value decrease all channels transmit power on FCC, it should work on Channel 1 / 11.

[2.4.0.2]
1. Fix issue: cannot read new efuse data.

[V2.4.0.0]
1. Rename crda.c to cfg80211.c, CRDA_SUPPORT to RT_CFG80211_SUPPORT.
2. Fix issue in 64bit CPU:
	(1) WMM ACM: see history of acm_comm.c.
	(2) Fix function RTMP_MapChannelID2KHZ().
3. Fix issue: error link list usage in 11r ric module in station mode.
4. Add an ATE command for AUTOALC.
5. Add an ATE command for interpacket GAP.
6. Add an ATE command for ATE payload pattern.
7. Fix issue: some reports from Prevent software analysis tool.
8. Fix WPS issue: some PIN cannot set successfully.(ex. 89134498)
9. Fix issue: STA send null frame with QoS field when STA connected to non-WMM AP.
10. Suport RFKILL: DO NOT set HAS_RFKILL_HW_SUPPORT=y in config.mk if device doesn't have HW radio on/off button. 
11. Reduce data packet lost while doing scan if STA already connects to AP.
12. Fix issue: If there are two APs with same SSID and security mode but have different WPAPSK, 
			   STA may always connect to AP with different WPAPSK if the RSSI of that AP is better than the correct one.
13. Support TxRx ring PRE-ALLOC in probe stage: set RESOURCE_PRE_ALLOC=y in config.mk.
14. Shorten the connection time: set FastConnect=1 in DAT file.
15. Update rt2870.bin: for fixing the 5G band RSSI loss in LED MODE 6/7/8/9/b/c.
16. Fix Adhoc issue: If there are more than 2 peers exist, driver didn't delete peer from entry table unless all peers left.
17. Fix issue: Correct RSSI, SNR, Noise calculations
18. Fix issue: STA cannot connect to OPEN-WEP AP if WpaSupplicant set WEPAUTO(IW_AUTH_ALG_SHARED_KEY | IW_AUTH_ALG_OPEN_SYSTEM) to driver.

[2.3.1.0]
1. CFG80211: Patch for Linux 2.6.32.

[2.3.0.0]
1. Support PSP XLINK in ad-hoc mode.
2. Add mac80211 iw utility other commands support.
3. Fix issue: The start address of HeaderBuf must be aligned by 4 when
   VENDOR_FEATURE1_SUPPORT is enabled.
4. WMM ACM: see history of acm_comm.c.
5. Support WpaSupplicant(v0.6.9) WPS
6. Fix WPS issue: Check SelectRegistrar is TRUE or FALSE
7. Fix WPS issue: Some AP (ex. Buffalo WZR-AG300NH) would change SSID to another SSID after push WPS PBC button.
				  After WPS process finish, change SSID to original SSID.
				  Driver needs to wait AP to re-generate Beacon; otherwise, driver will update this PBC SSID to MlmeAux.
8. Shorten the waiting time when unplug the device.
9. Fix mgmt ring full issue: It happened only in big-endian platform and quickly switch the network type between Infra and Adhoc mode.
10. Fix statistics issue: It happened in big-endian platform, tx count would be zero.
11. Support WiFi Draft_3.0 11n test items.
12. Support Linux Kernel 2.6.31
13. Support Ad-hoc WPS2PSK/AES (DPO doesn't support this item)
14. Support Samsung Auto Provision (only for Samsung Project)
15. For GPL issue: Separate three kernel modules - util module, driver module, netif module. util module and netif module could license GPL.
				   Driver module couldn't license GPL.

[V2.2.0.0]
1. Fixed issue of showing wrong statistics value.
2. Fixed problem of showing wrong SNR in wireless extension scan list.
3. Fixed WPA2PSK failed with some AP if key length is not zero in pairwise_msg_2 and pairwise_msg_4.
4. Add HAS_STATS_COUNT compile option.
5. Support TDLS.
6. Support Client WDS.
7. Support WMM ACM (Pass WiFi Test Plan v0.30).
8. Support the MAC assignment from configuration file(.dat).
9. Support Ethernet Convert in Ad-hoc mode.
10. Support SKU.

[V2.1.2.0]
>> DPA/DPB/DPC/DPD
1. Short GI sampling improvement.
2. Support Linux Kernel 2.6.29
3. Fixed driver would send zero IWEVASSOCREQIE to Native WpaSupplicant.
4. Fixed driver would send non-zero BSSID to Navtive WpaSupplicant when STA disconnecting to AP.
5. Check Addr1, Addr2 and Addr3 of de-auth packet from AP (driver only checked Addr2 of de-auth packet before).

[V2.1.2.0]
>> DPO
1. Short GI sampling improvement.
2. Check Addr1, Addr2 and Addr3 of de-auth packet from AP (driver only checked Addr2 of de-auth packet before).

[V2.1.1.0]
>> Only DPO project has this version
1. Fixed that Enqueue command to command thread would fail when HAS_KTHREAD_SUPPORT=n in config.mk.
2. Fixed driver would send zero IWEVASSOCREQIE to Native WpaSupplicant.
3. Fixed driver would send non-zero BSSID to Navtive WpaSupplicant when STA disconnecting to AP.
4. Support 2.6.29

[V2.1.0.0]
1. 	New generation schema for multiple OS porting
2. 	New chip support for RT3572
3.  Fixed Ad-hoc ping failed in noisy environment. (Probe Response has too many retry packet then cause "not enough space in MgmtRing")
4.  Modified iwpriv ra0 get_site_survey: 
	In scan list result: Security shows "NONE" when AP is OPEN/NONE,
								  shows "WEP"  when AP is OPEN/WEP or SHARED/WEP,
								  shows "WPAPSK(WPA2PSK)/TKIP(AES)" when AP is WPAPSK(WPA2PSK)/TKIP(AES)
								  shows "WPA(WPA2)/TKIP(AES)" when AP is WPA(WPA2)/TKIP(AES)
5.  Fixed WPS failed with D-Link DIR-628 in 5GHz.
6.  When cipher is WEP or TKIP, STA would connect to 11N AP with legacy rate.
	"iwpriv ra0 set HtDisallowTKIP=val": Enable/Disable N rate with 11N ap when cipher is WEP or TKIP.
	val: 
		0 : FALSE
		1 : TRUE
	Default setting is disable.
7.  Add "iwpriv ra0 wsc_ap_band val" command for setting prefer band to do WPS with dual band WPS AP.
	val:
        0 : prefer 2.4G
        1 : prefer 5G
        2 : auto
	Default value is auto (2) 
8.  Add "iwpriv ra0 set BeaconLostTime=val" command for user to change Beacon Lost Time.
	val:
		1 ~ 60 seconds
	Default value is 4 seconds
9.  Change FastRoaming in DAT file to AutoRoaming.
	Add "iwpriv ra0 set AutoRoaming=val" command for user to enable/disable auto roaming mechanism.
		0 : disable
		1 : enable
	Default setting is disable.

10.  Support kthread.
11.  Add "iwpriv ra0 set SiteSurvey=val" command for user to scan with specific SSID after Link Up.
	val:
		0~z, 1~32 ascii characters
12. Add New A band channel list region 15 contains the whole channels in the A band region 4 and the new CE channel 167,169,171,173.
13. New IEEE802.11r functionality.
14. New eFuse function and eFuse buffer mode.
15. fix mesh bugs.
16. fix mesh connection problem after setting WAPI security mode.
17. bug fixes.


[V2.0.1.0]
0. Finished verifying RT3071 STA support.
1. fix eFuse bug on big-endian platform
2. fix WMM problem for RT3071/72
3. fix one bug for ATE TX power handling and ATE frequency offset bug.
4. fix mesh crash issue
5. fix RT307x AMPDU throughput bug after interface down/up
6. fix RT307x difficult to enter power save mode issue.
7. fix a bug that is hard to connect with hidden-SSID AP.
8. update RT307x new firmware.

[V2.0.0.0]
1. Support new chips RT3070/71/72.
2. Lots of patch and bug fix from last release.
3. Support eFuse.
4. Support Antenna Diversity for RT3070.

[V1.4.0.0]
1. Add IWEVGENIE in iwlist ra0 scan.
2. Add new WSC hardware push button function
3. Add Ad-Hoc to support N rate.
4. Add "iwpriv ra0 set CarrierDetect=0(or 1)"
5. Add Station N only mode in Infra mode. (Only connects to N-AP)
6. Add Global country domain(ch1-11:active scan, ch12-14 passive scan)
7. Fixed connection failed with Range Maximizer - 515 AP (Marvell Chip) when security is WPAPSK/TKIP.
8. Fixed crash in LinkDown when there are >64 APs exists.
9. Fixed compile error when CARRIER_DETECTION_SUPPORT is enabled.
10. Fixed suspend/resume error when ra0 down, ra0 up
11. Modified iwpriv ra0 get_site_survey: When security of AP is OPEN/WEP or SHARED/WEP, show UNKNOW/WEP in scan list.
12. When the secondary channel of AP exceeds the country region's range, station will auto fallback to 20MHz. i.e. need both control and secondary channel are both
	in country region's channel list.
13. Migrate Mesh supporting to Draft-2.0.
14. Support DLS
15. Support WAPI functionality
16. Support Linux Kernel 2.6.27
17. Fixed WPS failed when AP is not in scan table or AP's channel changing after user sets "iwpriv ra0 wsc_start"
18. Add WPS Wireless Event strings.
19. Fixed WPA(2)PSK issue when group cipher of AP is WEP40 or WEP104.


[V1.3.1.0]
1. Fixed compile error on Linux Kernel 2.6.26
2. Fixed length error of RSN/SSN IE for WpaSupplicant.

[V1.3.0.0]
1. Fixed issue of Radar Channel flag building with HAS_EXT_BUILD_CHANNEL_LIST=n.
2. Fixed issue of Adhoc-STA would create in radar channel.
3. Fixed LED issue of "ifconfig ra0 down".
4. Support Mesh (DPO doesn't have Mesh mechanism.)
5. Support Linux Kernel 2.6.24
6. Support SNMP
7. Support Debug Diagnose
8. Add IEEE802.11d Client Mode: None, Flexible, Strcit.
9. Add two ioctl commands to change tx long/short retry limit.
10. Fixed WPS STA is hard to do WPS process with Broadcom WPS AP Proxy and Marvell WPS External Registrar.
11. Fixed WPS STA didn't send dis-assoc to AP after WPS processing.
12. Fixed WPAPSK rekey problem when A-MSDU is enabled.

[V1.2.2.0]
1. Fixed TX Bulk-Out Failed issue.
2. Fixed "iwlist ra0 scan" to show wpa_ie and rsn_ie when AP is WPAPSKWPA2PSK.
3. Support extened channel list.

[V1.2.1.0]
1. Fixed rate issue on Adhoc mode.
2. Fixed other Adhoc STA re-join failed with security.
3. Add "iwconfig rate" setting for legacy rate.
4. ATE: Add command "iwpriv ra0 set ATELDE2P=1" to overwrite all EEPROM contents from a .bin file.
5. Fixed issue of showing SNR1 information.
6. Add make install/uninstall to Makfile.

[V1.2.0.0]
1. New code base - RT28xx
2. Add Legacy Power Saving Mode.
3. Add BaSmartHardTransmit mechanism.
4. Modify rate adaptation for fast ramp-up tuning. 
5. Support custom wireless event.
6. Support Ethernet Convert Mechanism.
7. Support Linux Kernel 2.6 suspend and resume.
8. Fixed W52 with Activity scan issue in ABG_MIXED and ABGN_MIXED mode.
9. Fixed fixed rate issue in N mode and fixed rate ioctl.

[V 1.1.0.0]
1. WPS support.
2. Modified Link Status related information for Ralink WebUI.
3. Support WPA/WPA2-Enterprise and 802.11X WEP by using WPA_SUPPLICANT.
4. Fixed Ralink WebUI scan fault bug.
5. Fixed 1x authentication issue that STA will fail to authenticate when AP set fragmentation to 500.
6. Fixed WPS failed with Marvell external registrar.
7. Fixed mlme thread didn't de-queue when mlme queue full happened.
8. Fixed Adhoc WPANONE failed by setting from Ralink WebUI.
9. Fixed WPA(2)PSK failed when encryption type of AP is TKIP+AES.
10. Fixed Linux Kernel would dump warning messages when do RTUSB_VendorRequest in irq lock.

[V 1.0.0.0]
Create RT2870STA
>> Supported:
1. Security Mode : OPEN/NONE, OPEN/WEP, SHARED/WEP, WPA(2)PSK/TKIP, WPA(2)PSK/AES, WPANONE/TKIP, WPANONE/AES.
2. WMM capable.
3. HT MPDU Aggregation.
4. Little endian, x86 platform.
5. Ralink WebUI
